package javax.imageio.plugins.jpeg;

import javax.imageio.ImageReadParam;

public class JPEGImageReadParam extends ImageReadParam
{
    private JPEGQTable[] qTables;
    private JPEGHuffmanTable[] DCHuffmanTables;
    private JPEGHuffmanTable[] ACHuffmanTables;
    
    public JPEGImageReadParam() {
        this.qTables = null;
        this.DCHuffmanTables = null;
        this.ACHuffmanTables = null;
    }
    
    public boolean areTablesSet() {
        return this.qTables != null;
    }
    
    public void setDecodeTables(JPEGQTable[] array, JPEGHuffmanTable[] array2, JPEGHuffmanTable[] array3) {
        if (array == null || array2 == null || array3 == null || array.length > 4 || array2.length > 4 || array3.length > 4 || array2.length != array3.length) {
            throw new IllegalArgumentException("Invalid JPEG table arrays");
        }
        this.qTables = (JPEGQTable[])(JPEGQTable[])array.clone();
        this.DCHuffmanTables = (JPEGHuffmanTable[])(JPEGHuffmanTable[])array2.clone();
        this.ACHuffmanTables = (JPEGHuffmanTable[])(JPEGHuffmanTable[])array3.clone();
        return;
    }
    
    public void unsetDecodeTables() {
        this.qTables = null;
        this.DCHuffmanTables = null;
        this.ACHuffmanTables = null;
    }
    
    public JPEGQTable[] getQTables() {
        return (this.qTables != null) ? ((JPEGQTable[])(JPEGQTable[])this.qTables.clone()) : null;
    }
    
    public JPEGHuffmanTable[] getDCHuffmanTables() {
        return (this.DCHuffmanTables != null) ? ((JPEGHuffmanTable[])(JPEGHuffmanTable[])this.DCHuffmanTables.clone()) : null;
    }
    
    public JPEGHuffmanTable[] getACHuffmanTables() {
        return (this.ACHuffmanTables != null) ? ((JPEGHuffmanTable[])(JPEGHuffmanTable[])this.ACHuffmanTables.clone()) : null;
    }
}
